# -*- coding: utf-8 -*-
"""
   Wiki+ FullSearch Action Handler

   Copyright (C) 2005 Yong-Jin Cho <yongjin.cho@gmail.com>
   Wiki+ is distributed under GNU GPL. See COPYING for details.

   For more information, visit http://wikiplus.kldp.net.
"""
from wplus import *


def do(page_name, form):
    needle = form.getvalue('value', '')
    send_title('Full search for "%s"' % (needle))

    needle_re = re.compile(needle, re.IGNORECASE)
    page_list = get_page_list()
    hits = []
    for page in page_list:
        body = Page(page).get_text()
        match = needle_re.findall(body)
        count = len(needle_re.findall(body))
        if count:
            hits.append((count, page))

    # The default comparison for tuples compares elements in order,
    # so this sorts by number of hits
    hits.sort()
    hits.reverse()

    print '<ul>'
    for (count, page) in hits:
        print '<li>' + Page(page).link()
        print ' . . . . ' + `count`
        print ['match', 'matches'][count != 1] + '</li>'
    print '</ul>'

    print "<p>%d hits " % len(hits)
    print " out of %d pages searched." % len(page_list)

    send_footer(page_name, 1)
