# -*- coding: utf-8 -*-
"""
   Wiki+ Congifuration

   Copyright (C) 2005 Yong-Jin Cho <yongjin.cho@gmail.com>
   Wiki+ is distributed under GNU GPL. See COPYING for details.

   For more information, visit http://wikiplus.kldp.net.
"""
import os


# path to wikiplus
dir_prefix = '.'
data_dir = os.path.join(dir_prefix, 'data')
text_dir = os.path.join(data_dir, 'text')
backup_dir = os.path.join(data_dir, 'backup')
editlog_path = os.path.join(data_dir, 'editlog')


# url path to wikiplus
url_prefix = '/wikiplus'
logo_url = url_prefix + '/wplus.gif'
css_url = url_prefix + '/wplus.css'


#
charset = 'utf-8'
show_hosts = True
auto_linebreak = True
date_fmt = '%Y.%m.%d'
datetime_fmt = '%Y-%m-%d %I:%M:%S'
changed_time_fmt = '[%I:%M %p]'


# page names and button names
front_page = 'FrontPage'
recent_changes = 'RecentChanges'
find_page = 'FindPage'
title_index = 'TitleIndex'
edit_page = 'EditPage'
show_page = 'ShowPage'


# for uploading feature
upload_dir = os.path.join(dir_prefix, 'upload')
upload_url = url_prefix + '/upload'
allowed_ext = ('.txt', '.jpg', '.gif', '.bmp', '.png', '.jpeg', 
               '.hwp', '.doc', '.ppt', '.xls', '.pdf', '.ps',
               '.gz',  '.tgz', '.zip', '.rar', '.alz')
