# -*- coding: utf-8 -*-
"""
   Wiki+ RecentChanges Macro

   Copyright (C) 2005 Yong-Jin Cho <yongjin.cho@gmail.com>
   Wiki+ is distributed under GNU GPL. See COPYING for details.

   For more information, visit http://wikiplus.kldp.net.
"""
import time, socket, cStringIO
import config
from wplus import *


def expand(macro):
    lines = editlog_raw_lines(config.editlog_path)
    lines.reverse()
    
    buf = cStringIO.StringIO()
    ratchet_day = None
    done_names = {}
    for line in lines:
        page_name, mtime, host, comment = line[:-1].split('\t')
        page_name = unquote_name(page_name)

        if done_names.has_key(page_name):
            continue
        done_names[page_name] = 1

        # year, month, day, DoW
        time_tuple = time.localtime(float(mtime))
        day = tuple(time_tuple[0:3])
        if day != ratchet_day:
            if ratchet_day:
                buf.write('</ul>')
            buf.write('<h3>%s</h3><ul>' % time.strftime(config.date_fmt, time_tuple))
            ratchet_day = day

        buf.write('<li>')
        buf.write(Page(page_name).link())
        buf.write(' . . . . ')
        if config.show_hosts:
            try:
                buf.write(socket.gethostbyaddr(host)[0])
            except:
                buf.write(host)
            buf.write(' ')

        if config.changed_time_fmt:
            buf.write(time.strftime(config.changed_time_fmt, time_tuple))

        if comment:
            buf.write(' <span style="font-size:0.9em;color:#BBBBBB;">(')
            buf.write(comment)
            buf.write(')</span>')

        buf.write('</li>')
    buf.write('</ul>')

    return buf.getvalue()
