# -*- coding: utf-8 -*-
"""
   Wiki+ TitleIndex Macro

   Copyright (C) 2005 Yong-Jin Cho <yongjin.cho@gmail.com>
   Wiki+ is distributed under GNU GPL. See COPYING for details.

   There are some codes imported from MoinMoin.
   You can find information of MoinMoin at http://moinmoin.wikiwikiweb.de.

   For more information, visit http://wikiplus.kldp.net.
"""
import string, cStringIO
from wplus import *
import config


def get_index_group(name):
    c = name[0]
    if u'\uAC00' <= c <= u'\uD7AF': # Hangul Syllables
        return unichr(0xac00 + (int(ord(c) - 0xac00) / 588) * 588)
    else:
        return c


def expand(macro):
    page_list = get_page_list()
    tmp_list = map(lambda x: x.decode(config.charset), page_list)
    tmp_list = map(lambda x: (x.upper(), x), tmp_list)
    tmp_list.sort()
    page_list = map(lambda x: x[1], tmp_list)

    buf = cStringIO.StringIO()
    index_letters = []
    current_letter = None
    for name in page_list:
        letter = get_index_group(name)
        letter = letter.upper()
        if letter not in index_letters:
            index_letters.append(letter)

        if letter != current_letter:
            if current_letter:
                buf.write('</ul>')
            encoded_letter = letter.encode(config.charset)
            buf.write('<h2><a name="%s" href="#top">%s</a></h2><ul>' %
                                            (encoded_letter, encoded_letter))
            current_letter = letter

        buf.write('<li>%s</li>' % Page(name.encode(config.charset)).link())
    buf.write('</ul>')

    index = map(lambda x: x.encode(config.charset), index_letters)
    index = map(lambda x: '<a href="#%s">%s</a> ' % (x, x), index)
    top = '<a name="top"></a>'

    return top + string.join(index, ' | ') + buf.getvalue()
